VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "TrussMaster - Truss Generator"
   ClientHeight    =   7335
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6120
   Icon            =   "frmWizard.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7335
   ScaleWidth      =   6120
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtStatus 
      BackColor       =   &H80000000&
      Height          =   285
      Left            =   240
      Locked          =   -1  'True
      TabIndex        =   35
      Text            =   "Ready"
      Top             =   1080
      Width           =   5535
   End
   Begin VB.Frame Frame3 
      Caption         =   "Truss Geometry"
      Height          =   1335
      Left            =   240
      TabIndex        =   28
      Top             =   1560
      Width           =   5535
      Begin VB.TextBox txtPanels 
         Height          =   285
         Left            =   1800
         TabIndex        =   33
         Text            =   "7"
         Top             =   840
         Width           =   615
      End
      Begin VB.TextBox txtSpan 
         Height          =   285
         Left            =   1800
         TabIndex        =   30
         Text            =   "6"
         Top             =   360
         Width           =   615
      End
      Begin VB.TextBox txtHeight 
         Height          =   285
         Left            =   4440
         TabIndex        =   29
         Text            =   "1"
         Top             =   360
         Width           =   615
      End
      Begin VB.Label Label3 
         Caption         =   "No. Web Panels"
         Height          =   255
         Left            =   240
         TabIndex        =   34
         Top             =   840
         Width           =   1335
      End
      Begin VB.Label Label1 
         Caption         =   "Span (m)"
         Height          =   255
         Left            =   240
         TabIndex        =   32
         Top             =   360
         Width           =   855
      End
      Begin VB.Label Label2 
         Caption         =   "Height (m)"
         Height          =   255
         Left            =   3480
         TabIndex        =   31
         Top             =   360
         Width           =   855
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Loading Data"
      Height          =   1575
      Left            =   240
      TabIndex        =   20
      Top             =   5520
      Width           =   5535
      Begin VB.TextBox txtP 
         Enabled         =   0   'False
         Height          =   285
         Left            =   4440
         TabIndex        =   26
         Text            =   "1.2"
         Top             =   840
         Width           =   615
      End
      Begin VB.TextBox txtW 
         Height          =   285
         Left            =   4440
         TabIndex        =   25
         Text            =   "10"
         Top             =   360
         Width           =   615
      End
      Begin VB.OptionButton loading 
         Caption         =   "Top Chord Nodal Point Loads"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   22
         Top             =   840
         Width           =   2415
      End
      Begin VB.OptionButton loading 
         Caption         =   "Top Chord UDL"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   21
         Top             =   360
         Value           =   -1  'True
         Width           =   1575
      End
      Begin VB.Label Label16 
         Caption         =   "Note that 0.5P is applied to the end nodes of the top chord"
         Height          =   255
         Left            =   240
         TabIndex        =   27
         Top             =   1200
         Width           =   4695
      End
      Begin VB.Label lblP 
         Caption         =   "P (kN)"
         Enabled         =   0   'False
         Height          =   255
         Left            =   3360
         TabIndex        =   24
         Top             =   840
         Width           =   975
      End
      Begin VB.Label lblW 
         Caption         =   "w (kN/m)"
         Height          =   255
         Left            =   3360
         TabIndex        =   23
         Top             =   360
         Width           =   1095
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Member Data"
      Height          =   2175
      Left            =   240
      TabIndex        =   3
      Top             =   3120
      Width           =   5535
      Begin VB.CheckBox chkConstE 
         Caption         =   "Constant E value"
         Height          =   255
         Left            =   240
         TabIndex        =   19
         Top             =   1680
         Value           =   1  'Checked
         Width           =   1575
      End
      Begin VB.TextBox txtEweb 
         Enabled         =   0   'False
         Height          =   285
         Left            =   4440
         TabIndex        =   18
         Text            =   "205"
         Top             =   1320
         Width           =   615
      End
      Begin VB.TextBox txtAweb 
         Height          =   285
         Left            =   2520
         TabIndex        =   16
         Text            =   "100"
         Top             =   1320
         Width           =   735
      End
      Begin VB.TextBox txtEbtm 
         Enabled         =   0   'False
         Height          =   285
         Left            =   4440
         TabIndex        =   13
         Text            =   "205"
         Top             =   840
         Width           =   615
      End
      Begin VB.TextBox txtAbtm 
         Height          =   285
         Left            =   2520
         TabIndex        =   11
         Text            =   "100"
         Top             =   840
         Width           =   735
      End
      Begin VB.TextBox txtEtop 
         Height          =   285
         Left            =   4440
         TabIndex        =   8
         Text            =   "205"
         Top             =   360
         Width           =   615
      End
      Begin VB.TextBox txtAtop 
         Height          =   285
         Left            =   2520
         TabIndex        =   6
         Text            =   "100"
         Top             =   360
         Width           =   735
      End
      Begin VB.Label lblEweb 
         Caption         =   "E (kN/mm2)"
         Enabled         =   0   'False
         Height          =   255
         Left            =   3480
         TabIndex        =   17
         Top             =   1320
         Width           =   855
      End
      Begin VB.Label Label12 
         Caption         =   "Area (mm2)"
         Height          =   255
         Left            =   1560
         TabIndex        =   15
         Top             =   1320
         Width           =   855
      End
      Begin VB.Label Label11 
         Caption         =   "Web "
         Height          =   255
         Left            =   240
         TabIndex        =   14
         Top             =   1320
         Width           =   975
      End
      Begin VB.Label lblEbtm 
         Caption         =   "E (kN/mm2)"
         Enabled         =   0   'False
         Height          =   255
         Left            =   3480
         TabIndex        =   12
         Top             =   840
         Width           =   855
      End
      Begin VB.Label Label9 
         Caption         =   "Area (mm2)"
         Height          =   255
         Left            =   1560
         TabIndex        =   10
         Top             =   840
         Width           =   855
      End
      Begin VB.Label Label8 
         Caption         =   "Btm Chord:"
         Height          =   255
         Left            =   240
         TabIndex        =   9
         Top             =   840
         Width           =   975
      End
      Begin VB.Label Label7 
         Caption         =   "E (kN/mm2)"
         Height          =   255
         Left            =   3480
         TabIndex        =   7
         Top             =   360
         Width           =   855
      End
      Begin VB.Label Label6 
         Caption         =   "Area (mm2)"
         Height          =   255
         Left            =   1560
         TabIndex        =   5
         Top             =   360
         Width           =   855
      End
      Begin VB.Label Label5 
         Caption         =   "Top Chord:"
         Height          =   255
         Left            =   240
         TabIndex        =   4
         Top             =   360
         Width           =   975
      End
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   2880
      Top             =   360
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton btnGenerate 
      Caption         =   "Generate Truss File"
      Height          =   495
      Left            =   3480
      TabIndex        =   2
      Top             =   360
      Width           =   2295
   End
   Begin VB.ComboBox cmbTrussType 
      Height          =   315
      Left            =   240
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   480
      Width           =   2535
   End
   Begin VB.Label Label4 
      Caption         =   "Truss web configuration"
      Height          =   255
      Left            =   240
      TabIndex        =   1
      Top             =   240
      Width           =   2415
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
'    Copyright (C) 2008  Colin Caprani - www.colincaprani.com
'
'    This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Private m_truss As clsTruss
Attribute m_truss.VB_VarHelpID = -1
Private openfile As String
Private loadType As Integer, loadValue As Single

Private Sub chkConstE_Click()
If chkConstE.Value Then
    txtEbtm.Enabled = False
    txtEweb.Enabled = False
    lblEbtm.Enabled = False
    lblEweb.Enabled = False
Else
    txtEbtm.Enabled = True
    txtEweb.Enabled = True
    lblEbtm.Enabled = True
    lblEweb.Enabled = True
End If
End Sub

Private Sub btnGenerate_Click()

txtStatus.Text = "Generating truss file...."

Set m_truss = New clsTruss

Call FileSave

With m_truss
    Select Case cmbTrussType.Text
        Case "Pratt Truss"
            .config = 1
        Case Else
            .config = 1 'just for now
    End Select
    If chkConstE.Value Then
        .topE = CSng(txtEtop.Text)
        .btmE = CSng(txtEtop.Text)
        .webE = CSng(txtEtop.Text)
    Else
        .topE = CSng(txtEtop.Text)
        .btmE = CSng(txtEbtm.Text)
        .webE = CSng(txtEweb.Text)
    End If
    .topA = CSng(txtAtop.Text)
    .btmA = CSng(txtAbtm.Text)
    .webA = CSng(txtAweb.Text)
    .loadType = loadType
    If loadType = 1 Then
        loadValue = CSng(txtW.Text)
    Else
        loadValue = CSng(txtP.Text)
    End If
    .loadValue = loadValue
    .L = CSng(txtSpan.Text)
    .h = CSng(txtHeight.Text)
    .np = CInt(txtPanels.Text)
    .openfile = openfile
    .saveFile
End With

txtStatus.Text = "Generation completed"
MsgBox "Generation Completed Successfully", vbInformation, "TrussGenerator"

End Sub

Private Sub FileSave()
'Save = true, Save as = False
Dim FNum As Integer, sFile As String

On Error GoTo FileError
    With CommonDialog1
        .DialogTitle = "Save"
        .Flags = cdlOFNOverwritePrompt
        .CancelError = True
        .DefaultExt = "trm"
        .InitDir = "C:\windows\desktop\TRM"
        .Filter = "TrussMaster files|*.trm|All files|*.*"
        .ShowSave
        If Len(.FileName) = 0 Then
            MsgBox "Please Name a File", vbInformation, "TrussGenerator"
            Call FileSave
            Exit Sub
        End If
        openfile = .FileName
    End With
    
    Exit Sub

FileError:
    If Err.Number = cdlCancel Then Exit Sub
End Sub


Private Sub Form_Load()
cmbTrussType.AddItem "Pratt Truss"
cmbTrussType.AddItem "Others to follow"
End Sub

Private Sub Form_Unload(Cancel As Integer)
Set m_truss = Nothing
End Sub

Private Sub loading_Click(Index As Integer)
Select Case Index
    Case 0
        lblP.Enabled = False
        txtP.Enabled = False
        lblW.Enabled = True
        txtW.Enabled = True
        loadType = 1
    Case Else
        lblW.Enabled = False
        txtW.Enabled = False
        lblP.Enabled = True
        txtP.Enabled = True
        loadType = 2
End Select
End Sub

Private Sub Frame1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
txtStatus.Text = "Enter member data here"
End Sub
Private Sub Frame2_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
txtStatus.Text = "Enter load data here"
End Sub
Private Sub Frame3_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
txtStatus.Text = "Enter geometry of the truss here"
End Sub
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
txtStatus.Text = "Ready"
End Sub

Private Sub txtAbtm_Change()
Call numberCheck(txtAbtm)
End Sub

Private Sub txtAtop_Change()
Call numberCheck(txtAtop)
End Sub

Private Sub txtAweb_Change()
Call numberCheck(txtAweb)
End Sub

Private Sub txtEbtm_Change()
Call numberCheck(txtAbtm)
End Sub

Private Sub txtEtop_Change()
Call numberCheck(txtEtop)
End Sub

Private Sub txtEweb_Change()
Call numberCheck(txtEweb)
End Sub

Private Sub txtHeight_Change()
Call numberCheck(txtHeight)
End Sub

Private Sub txtP_Change()
Call numberCheck(txtP)
End Sub

Private Sub txtPanels_Change()
Call numberCheck(txtPanels)
End Sub

Private Sub txtSpan_Change()
Call numberCheck(txtSpan)
End Sub

Private Sub txtW_Change()
Call numberCheck(txtW)
End Sub

Private Sub numberCheck(tb As TextBox)
Dim txt As String

txt = tb.Text
If Not IsNumeric(txt) Then
    If Not txt = "" Then
        MsgBox "Please enter a number", vbExclamation, "TrussGenerator"
        tb.Text = ""
    End If
End If
End Sub
